
#include "hash.h"
#include "words.h"
#include "locallib.h"
#include "mg.h"
#include "translation.h"
#include "memlib.h"
#include "stem_french.h"

#define MAX_LINE 200
#define MAX_WORD 250

#define INITIAL_HASH_SIZE 7927
#define POOL_SIZE 1024*1024
#define MAX_WORD_LEN 250


u_char * hashPool;
int hashPoolLeft;


/*int 
prime (int p)
{
   int limit;
   p += (p & 1) + 1;
  limit = (int) sqrt ((double) p) + 1;
  do
    {
      int j;
      while (limit * limit < p)
	limit++;
      for (j = 3; j <= limit && p % j; j += 2)
      ;			// NULLBODY 
      if (j > limit)
	break;
      p += 2;
    }
  while (1);
  return (p);
}
*/

void lower_case(u_char * word)
{
  int i=0;

  for (i=0; i<strlen(word); i++)
    word[i]=tolower(word[i]);
}


tr_hash *  init_trans(FILE * ftr, int * hsize, char q_type,void * stemmer)
{
  u_char line[MAX_LINE];
  u_char * ptr=NULL, *ptr1=NULL;
  u_char w[MAX_WORD], trw[MAX_WORD];
  unsigned long hashval, step;
  tr_hash * ent;
  int len,n,num_it=1;
  u_char * s1,* s2, *swd;
  int hashsize =  INITIAL_HASH_SIZE;
  int hashused = 0;
  tr_hash * hashtable;
  u_char tmpw[MAX_WORD];
  if (!(hashPool = Xmalloc (POOL_SIZE)))
    {
      return NULL;
      exit(0);
    }
  hashPoolLeft = POOL_SIZE;
  hashtable = Xmalloc(sizeof(tr_hash)*hashsize);  
  if (!hashtable)     
    {
      fprintf(stderr, "no memory for hashtable\n");
      exit(0);
    //    FatalError(1, "No memory for hashtable\n");
    }
  bzero((char*)(hashtable), sizeof(tr_hash) * hashsize);
  hashused = 0;

  while (fgets(line, MAX_LINE, ftr)) {
    //    printf("%s - - %d\n",line,strlen(line));
    if (ptr = strchr(line, '\t')) 
      {
	*ptr = '\0';
	//	printf("%s - - %d\n",line,strlen(line));
	ptr++;
	//	ptr++;
	if(ptr1 = strchr(ptr,'\n')) {
	  *ptr1 = '\0';
	  //	  printf("%s - - %d\n",ptr,strlen(ptr));
	}
	else continue;
      }
    else continue;
    lower_case(ptr);
    lower_case(line);
    //    printf("%s - - %d\n",line,strlen(line));
    if (q_type == 'P') {
      w[0]=(u_char)strlen(line);
      memcpy(&(w[1]),line,w[0]);
    }
    else  {
      w[0]=(u_char)strlen(ptr);
      memcpy(&(w[1]),ptr,w[0]);
      ptr=line;
    }

   if (stemmer)
      num_it=2;
    else num_it=1;

   for (n=0; n<num_it; n++) { 
     if (n==1 && stemmer)
       {
	 swd=(u_char*)french_stem(stemmer, line, 0, strlen(line)-1);
	 //   printf("swd %s\n",swd);
	 memcpy(&(w[1]),swd,strlen(swd));
	 w[0]=strlen(swd);
       }
      HASH(hashval,step,w, hashsize); 
      for (;;) {
	ent = hashtable + hashval;
	if (!ent->word) {
	  len = w[0]+1;
	  if(len > hashPoolLeft)
	    {
	      if (!(hashPool = Xmalloc(POOL_SIZE))) {
		// Message ("Unable to allocate memory for hash pool");
		return NULL;
	      }
	      hashPoolLeft = POOL_SIZE;	    
	    }
	  ent->word = hashPool;
	  memcpy(hashPool,w,len);
	  hashPool+=len;
	  hashPoolLeft -= len;
	  len= strlen(ptr)+1;
	  trw[0] = len-1;
	  memcpy(&(trw[1]),ptr,len-1);
	  if(len > hashPoolLeft) 
	    {
	      if (!(hashPool = Xmalloc(POOL_SIZE))) {
		//Message ("Unable to allocate memory for hash pool");
		return NULL;
	      }
	      hashPoolLeft = POOL_SIZE;	    
	    }	  
	  if (!ent->num_tr)
	    ent->tr = Xmalloc(sizeof(u_char*)*MAX_TRANS);
	  ent->tr[ent->num_tr++]=hashPool;
	  memcpy(hashPool, trw,len);
	  hashPool+=len;
	  hashPoolLeft -= len;
	  hashused++;
	  break;
	}
	s1 = w;
	s2 = ent->word;
	len = *s1 + 1;
	for (; len; len--) {
	  if ((*s1) != (*s2))
	    break;
	  s1++;
	  s2++;
	}
	if (len)
	  {
	    hashval = (hashval + step);
	    if (hashval >= hashsize)
	      hashval -= hashsize;
	  }
	else
	  {
	    if (n==0) {
	      if (ent->num_tr < MAX_TRANS) {
		len= strlen(ptr)+1;
		trw[0] = len-1;
		memcpy(&(trw[1]),ptr,len-1);
		if(len > hashPoolLeft) 
		  {
		    if (!(hashPool = Xmalloc(POOL_SIZE))) {
		    //		Message ("Unable to allocate memory for hash pool");
		      return NULL;
		    }
		    hashPoolLeft = POOL_SIZE;	    
		  }	  	  
		ent->tr[ent->num_tr++]=hashPool;
		memcpy(hashPool, trw,len);
		hashPool+=len;
		hashPoolLeft -= len;
	      }
	    }
	    break;
	  }
      }
      if (hashused >= hashsize >> 1)
	{
	  tr_hash *ht;
	  unsigned long size;
	  unsigned long i;
	  size = prime (hashsize * 2);
	  if (!(ht = Xmalloc (sizeof (tr_hash) * size)))
	    {
	      //	      Message ("Unable to allocate memory for table");
	      return NULL;
	    }

	  bzero ((char *) ht, sizeof (tr_hash) * size);
	  
	  for (i = 0; i < hashsize; i++)
	    if (hashtable[i].word)
	      {
		register u_char *wptr;
		register unsigned long hashval, step;
		
		wptr = hashtable[i].word;
		HASH (hashval, step, wptr, size);
		wptr = (ht + hashval)->word;
		while (wptr)
		  {
		    hashval += step;
		    if (hashval >= size)
		      hashval -= size;
		    wptr = (ht + hashval)->word;
		  }
		ht[hashval] = hashtable[i];
	      }
	  Xfree (hashtable);
	  hashtable = ht;
	  hashsize = size;
	}
   }
    //    printf("I am here reading next line\n");
  }
  //  printf("exiting init staff %d\n",hashsize);
  *hsize = hashsize;
  return hashtable;
}

void get_avg_translations(tr_hash * hashtable, int hashsize, int * ntrans, int * nwords )
{
  int i=0;
  tr_hash * ent;
  int tot_words=0;
  int tot_trans=0;

  for (i=0; i<hashsize; i++) 
    {
      ent = hashtable+i;
      if (ent->word) {
	tot_words++;
	tot_trans += ent->num_tr;
      }
    }
  *nwords=tot_words;
  *ntrans = tot_trans;
} 

int translate_word(u_char * word, u_char ***trs, tr_hash * hashtable, int hashsize)
{
  u_char *s1, *s2;
  tr_hash * ent;
  unsigned long hashval,step;
  int len,i;

  HASH(hashval, step, word, hashsize);
  //  fprintf(stderr, "hashval: %ld, step:%ld\n", hashval, step);
  for(;;) 
    {
      ent = hashtable+hashval;
      if (!ent->word) {
	//	fprintf(stderr, "no word in hash table\n");
	return 0;
      }
      else {
	s1 = word;
	s2 = ent->word;
	len = *s1 + 1;
	for (; len; len--) {
	  if ((*s1) != (*s2))
	    break;
	  s1++;
	  s2++;
	}
	if (len)
	  {
	    hashval = (hashval + step);
	    if (hashval >= hashsize)
	      hashval -= hashsize;
	  }
	else 
	  {
	    //	    fprintf(stderr,"word is found no tr: %d\n", ent->num_tr);
	    *trs=ent->tr;
	    return ent->num_tr;
	  }
      }
    }
  return 0;
}


int get_trans(u_char * buf, int len, tr_hash * hashtable, int hashsize, u_char * outbuf, char q_type, void * stemmer, int maxit)
{
  u_char  *sout;
  u_char * end, *start=buf;
  u_char *s1, *s2;
  int ifword, olen,i;
  unsigned long hashval, step;
  tr_hash * ent;
  u_char tmpw[MAX_WORD];
  int e;

  //  setlocale(LC_ALL, "en_US.ISO8859-15");
  //  e='';
  //  if (INAWORD(e))
  //  printf("FUNDA FUNDA NIYE: %c -- %d\n",e,e);
  if (len <= 0) return len; 
  //  outbuf = Xmalloc(sizeof(u_char)*MAX_TRANS*len);
  sout = outbuf;
  end = start + len +1;

  if (!hashtable) {
    exit(0);
  }
  //  printf("MAXIT: %d\n", maxit);

  ifword = INAWORD(*buf);
   
  for (; start <= end; ifword=!ifword)
    {
      u_char word[MAX_WORD_LEN+1];
      u_char phrase[MAX_WORD_LEN*10+1];
      u_char wd[MAX_WORD_LEN*10+1];
      u_char * swd;
      int mit=maxit, it;
      u_char * phtmp=phrase+1;
      u_char * start1;
      int flag=1;
      int phase = 1;
      //      if (ifword)
      //	PARSE_WORD(word, start, end);
      //  else 
      //	PARSE_NON_WORD(word, start, end);
      //      fprintf(stderr,"%d -- %d -- %s\n",ifword, *word, &(word[1]));
      
      if (ifword) {
	while (flag) {
	  if (phase == 1) {
	    phtmp=phrase+1;
	    start1=start;
	  
	    for (it=0; it<mit; it++)
	      {
		//		printf("phase:%d\n",phase);	 
		PARSE_WORD(word,start1,end);
		memcpy(phtmp, &(word[1]),word[0]);
		//	      printf("phtmp: %c\n", *phtmp);
		phtmp+=word[0];
		//	      printf("phtmp: %c\n", *phtmp);
		//	      printf("%d\n", phtmp-phrase);
		//	      memcpy(tmpw, &(word[1]), word[0]);
		//	      tmpw[word[0]]='\0';
		//	      printf("word: %s\n",tmpw);
		if (it < mit-1) {
		  PARSE_NON_WORD(word,start1, end);
		  memcpy(phtmp, &(word[1]),word[0]);
		  phtmp+=word[0];
		}		
	      }
	  //	  if (phase == 1) 
	    phrase[0]=((int)(phtmp-phrase))-1;
	  }
	  
	  //	  printf("phrase length: %d\n", phrase[0]);
	  //	  memcpy(tmpw, &(phrase[1]), phrase[0]);
	  //	  tmpw[phrase[0]]='\0';
	  //	  printf("phrase: %s\n",tmpw);
	  lower_case(phrase);
	  if (stemmer && phase==2)
	    {
	      //	      printf("Stemming word\n");
	      memcpy(wd, &(phrase[1]),phrase[0]);
	      wd[phrase[0]]='\0';
	      //	      printf("wd: %s\n",wd);
	      swd=(u_char*)french_stem(stemmer, wd, 0, strlen(wd)-1);
	      //   printf("swd %s\n",swd);
	      memcpy(&(phrase[1]),swd,strlen(swd));
	      phrase[0]=strlen(swd);
	    }
	  /*	  memcpy(tmpw, &(phrase[1]),phrase[0]);
	  tmpw[phrase[0]]='\0';
	  printf("phrase: %s\n",tmpw);*/
	  HASH(hashval, step, phrase, hashsize);
	  for(;;) 
	    {
	      ent = hashtable+hashval;
	      if (!ent->word) {
		//	      fprintf(stderr, "no word in hash table\n");
		if (phase == 1) {
		  //		  printf("not found going to 2nd phase\n");
		  phase = 2;
		}
		else if (phase == 2) {
		  //		  printf("not found in phase 2\n");
		  mit--;
		  phase = 1;
		}
		//		printf("Couldn't found in dict, continuing ...\n");
		if (!mit)
		  {
		    //		    printf("couldn't found dictinary, breaking ...\n");
		    memcpy(sout, &(phrase[1]),*phrase);
		    sout += *phrase;
		    *sout = ' ';
		    sout++;
		    start=start1;
		    flag=0;
		    break;
		  }
		break;
	      }
	      else {
		s1 = phrase;
		s2 = ent->word;
		len = *s1 + 1;
		for (; len; len--) {
		  if ((*s1) != (*s2))
		    break;
		  s1++;
		  s2++;
		}
		if (len)
		  {
		    hashval = (hashval + step);
		    if (hashval >= hashsize)
		      hashval -= hashsize;
		  }
		else 
		  {
		    //		    printf("found in dict, breaking\n");
		  //		  fprintf(stderr,"word is found no tr: %d\n", ent->num_tr);
		    if (q_type == 'B')
		      {
			for (i=0; i<MAX_TRANS; i++) {
			  memcpy(sout, &(ent->tr[i%ent->num_tr][1]), 
				 ent->tr[i%ent->num_tr][0]);
			  sout = sout + ent->tr[i%ent->num_tr][0];
			  *sout = ' ';
			  sout++;
			}
		      }
		    else 
		      {	
			if (phase == 2) {
			  //			  printf("Found in phase 2\n");
			  phase=1;
			}
			//			else printf("Found in phase 1\n");
			for (i=0;i<ent->num_tr;i++) {
			  memcpy(sout, &(ent->tr[i][1]), ent->tr[i][0]);
			  sout = sout + ent->tr[i][0];
			  *sout = ' ';
			  sout++;
			}
		      }
		    start=start1;
		    flag=0;
		    break;
		  }
	      }
	    }
	}
      }
      else {
      	PARSE_NON_WORD(word, start, end);
	memcpy(sout, &(word[1]),*word);
	sout += *word;
      }	
    }
  olen = sout - outbuf+1;
  //  memcpy(buf, outbuf, olen);
  // Xfree(outbuf);
  return olen;
}


/*int main()
{
  
 FILE * fptr = fopen("/fs/circle2/resnik/ftp/dicts/fre-en.txt","r"); 

  int data  = open("aa",O_RDONLY);
 int num;
  tr_hash * hash;
  u_char * start, *end;
  int size;
  u_char * end_pos = Xmalloc(sizeof(u_char)*10000);
  u_char * outbuf = Xmalloc(sizeof(u_char)*20000);
  u_char ** trs;
  int ntr=0; 
  int i=0;
  int ifword;

  if (!fptr) {exit(0);}
  

  //  hash=(tr_hash **)malloc(sizeof(tr_hash*));
  hash=init_trans(fptr,  &size, 1); 

  if (!hash) 
    exit(0);
  fprintf(stderr, "size : %d \n",size);
  //  fprintf(stderr,"sdcvhbsdjnbc\n");
  if (data) {
    //    fprintf(stderr, "heeey ordamisin\n");
    num=read(data,end_pos, 10000);
    //fprintf(stderr,"%d \n",num);
    fprintf(stderr,"%d %s\n",num,end_pos);
    start = end_pos;
    end = start + num + 1;
    //   fprintf(stderr,"%d -- %d -- %s\n",ifword, *word, &(word[1]));
    fprintf(stderr, "now getting data\n");
 
    num=get_trans(end_pos, num, hash, size,outbuf);
    printf("%d - %s\n",num, outbuf);
  }
  else fprintf(stderr, "oooch!!!\n"); 
    
}
*/

int get_stem(u_char * buf, int len, u_char * obuf)
{
  FILE * finw;
  FILE * fout;
  u_char * end, * start=buf;
  u_char * ebuf=obuf;
  int olen=0;
  int ifword;

  end = start+len+1;
  ifword = INAWORD(*buf);
  
  //  fprintf(stderr, "heeeyyy we start meeen\n");
  for (; start <= end; ifword=!ifword)
    {
      u_char word[MAX_WORD_LEN+1];
      u_char w[MAX_WORD_LEN+1];

      if (ifword)
	PARSE_WORD(word, start, end);
      else 
	PARSE_NON_WORD(word, start, end);
      
      if (ifword) 
	{
	  memcpy(w, &(word[1]),word[0]); 
	  w[word[0]]='\0';
	  //	  	  printf("original %s\n",w); 
	  finw=fopen("tempinw.txt", "w");
	  fprintf(finw, "%s\n", w);
	  fclose(finw);
	  system("/fs/kyrie9/Multiling/muscat_stem/om/languages/french/stem_french < tempinw.txt > tempout.txt");
	  fout=fopen("tempout.txt","r");
	  fscanf(fout, "%s", w);
	  fclose(fout);
	  // 	  printf("stemmed %s\n",w);
	  memcpy(ebuf, w, strlen(w));
	  ebuf+=strlen(w);
	}
      else
	{
	  memcpy(ebuf,&(word[1]),word[0]);
	  ebuf+=*word;
	} 
    }

  remove("tempinw.txt");
  remove("tempout.txt");

  return ebuf-obuf;
}
